package org.eclipse.jdt.internal.compiler.ast;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.eclipse.jdt.internal.compiler.ASTVisitor;
import org.eclipse.jdt.internal.compiler.ast.ASTNode;
import org.eclipse.jdt.internal.compiler.ast.ExplicitConstructorCall;
import org.eclipse.jdt.internal.compiler.ast.ThisReference;
import org.eclipse.jdt.internal.compiler.impl.Constant;
import org.eclipse.jdt.internal.compiler.lookup.BlockScope;
import org.eclipse.jdt.internal.compiler.lookup.ReferenceBinding;
import org.eclipse.jdt.internal.compiler.lookup.TypeBinding;

public class SuperReference extends ThisReference {
  public SuperReference(int sourceStart, int sourceEnd) {
    super(sourceStart, sourceEnd);
  }
  
  public static ExplicitConstructorCall implicitSuperConstructorCall() {
    return new ExplicitConstructorCall(1);
  }
  
  public boolean isImplicitThis() {
    return false;
  }
  
  public boolean isSuper() {
    return true;
  }
  
  public boolean isUnqualifiedSuper() {
    return true;
  }
  
  public boolean isThis() {
    return false;
  }
  
  public StringBuffer printExpression(int indent, StringBuffer output) {
    return output.append("super");
  }
  
  public TypeBinding resolveType(BlockScope scope) {
    this.constant = Constant.NotAConstant;
    ReferenceBinding enclosingReceiverType = scope.enclosingReceiverType();
    if (!checkAccess(scope, enclosingReceiverType))
      return null; 
    if (enclosingReceiverType.id == 1) {
      scope.problemReporter().cannotUseSuperInJavaLangObject((ASTNode)this);
      return null;
    } 
    return this.resolvedType = (TypeBinding)enclosingReceiverType.superclass();
  }
  
  public void traverse(ASTVisitor visitor, BlockScope blockScope) {
    visitor.visit(this, blockScope);
    visitor.endVisit(this, blockScope);
  }
}
